# coding: utf-8

"""
    RegObs API

      ## Introduction    RegObs is a tool for collecting observations and events   related to natural hazards. It is currently used by the   Norwegian flood, landslide and avalanche warning service in   Norway, but the data is openly available for anyone through this API.    Regobs has been developed by the Norwegian Water resources and   Energy Directorate (NVE), in collaboration with the Norwegian   Meteorological Institute (MET) and the Norwegian Public Roads   Administration (NPRA).    You can check out our representation of the data at [regobs.no](http://regobs.no).    ## Authentication    Some endpoints require an api key.  You can get an API key by sending an email to   [raek@nve.no](mailto:raek@nve.no?subject=RegObs%20API%20Key).  To use the api key with the swagger ui, fill in the api\\_key input above.   It should then be included with every request in the   `regObs_apptoken` header.    ## Getting started    Get the last 10 observations using python:    ```python  import requests  r = requests.post('https://api.regobs.no/v4/Search',       data={'NumberOfRecords': 10},      headers={'Content-Type': 'application/json'}  )  data = r.json()  print(len(data))  # 10  ```      # noqa: E501

    OpenAPI spec version: v4
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class CreateAccountRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'user_name': 'str',
        'password': 'str',
        'confirm_password': 'str',
        'email': 'str'
    }

    attribute_map = {
        'user_name': 'UserName',
        'password': 'Password',
        'confirm_password': 'ConfirmPassword',
        'email': 'Email'
    }

    def __init__(self, user_name=None, password=None, confirm_password=None, email=None):  # noqa: E501
        """CreateAccountRequest - a model defined in Swagger"""  # noqa: E501
        self._user_name = None
        self._password = None
        self._confirm_password = None
        self._email = None
        self.discriminator = None
        if user_name is not None:
            self.user_name = user_name
        if password is not None:
            self.password = password
        if confirm_password is not None:
            self.confirm_password = confirm_password
        if email is not None:
            self.email = email

    @property
    def user_name(self):
        """Gets the user_name of this CreateAccountRequest.  # noqa: E501


        :return: The user_name of this CreateAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._user_name

    @user_name.setter
    def user_name(self, user_name):
        """Sets the user_name of this CreateAccountRequest.


        :param user_name: The user_name of this CreateAccountRequest.  # noqa: E501
        :type: str
        """

        self._user_name = user_name

    @property
    def password(self):
        """Gets the password of this CreateAccountRequest.  # noqa: E501


        :return: The password of this CreateAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password):
        """Sets the password of this CreateAccountRequest.


        :param password: The password of this CreateAccountRequest.  # noqa: E501
        :type: str
        """

        self._password = password

    @property
    def confirm_password(self):
        """Gets the confirm_password of this CreateAccountRequest.  # noqa: E501


        :return: The confirm_password of this CreateAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._confirm_password

    @confirm_password.setter
    def confirm_password(self, confirm_password):
        """Sets the confirm_password of this CreateAccountRequest.


        :param confirm_password: The confirm_password of this CreateAccountRequest.  # noqa: E501
        :type: str
        """

        self._confirm_password = confirm_password

    @property
    def email(self):
        """Gets the email of this CreateAccountRequest.  # noqa: E501


        :return: The email of this CreateAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this CreateAccountRequest.


        :param email: The email of this CreateAccountRequest.  # noqa: E501
        :type: str
        """

        self._email = email

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateAccountRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateAccountRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
