# coding: utf-8

"""
    RegObs API

      ## Introduction    RegObs is a tool for collecting observations and events   related to natural hazards. It is currently used by the   Norwegian flood, landslide and avalanche warning service in   Norway, but the data is openly available for anyone through this API.    Regobs has been developed by the Norwegian Water resources and   Energy Directorate (NVE), in collaboration with the Norwegian   Meteorological Institute (MET) and the Norwegian Public Roads   Administration (NPRA).    You can check out our representation of the data at [regobs.no](http://regobs.no).    ## Authentication    Some endpoints require an api key.  You can get an API key by sending an email to   [raek@nve.no](mailto:raek@nve.no?subject=RegObs%20API%20Key).  To use the api key with the swagger ui, fill in the api\\_key input above.   It should then be included with every request in the   `regObs_apptoken` header.    ## Getting started    Get the last 10 observations using python:    ```python  import requests  r = requests.post('https://api.regobs.no/v4/Search',       data={'NumberOfRecords': 10},      headers={'Content-Type': 'application/json'}  )  data = r.json()  print(len(data))  # 10  ```      # noqa: E501

    OpenAPI spec version: v4
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class DangerObsViewModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'danger_obs_id': 'int',
        'geo_hazard_tid': 'int',
        'geo_hazard_name': 'str',
        'danger_sign_tid': 'int',
        'danger_sign_name': 'str',
        'comment': 'str'
    }

    attribute_map = {
        'danger_obs_id': 'DangerObsID',
        'geo_hazard_tid': 'GeoHazardTID',
        'geo_hazard_name': 'GeoHazardName',
        'danger_sign_tid': 'DangerSignTID',
        'danger_sign_name': 'DangerSignName',
        'comment': 'Comment'
    }

    def __init__(self, danger_obs_id=None, geo_hazard_tid=None, geo_hazard_name=None, danger_sign_tid=None, danger_sign_name=None, comment=None):  # noqa: E501
        """DangerObsViewModel - a model defined in Swagger"""  # noqa: E501
        self._danger_obs_id = None
        self._geo_hazard_tid = None
        self._geo_hazard_name = None
        self._danger_sign_tid = None
        self._danger_sign_name = None
        self._comment = None
        self.discriminator = None
        if danger_obs_id is not None:
            self.danger_obs_id = danger_obs_id
        if geo_hazard_tid is not None:
            self.geo_hazard_tid = geo_hazard_tid
        if geo_hazard_name is not None:
            self.geo_hazard_name = geo_hazard_name
        if danger_sign_tid is not None:
            self.danger_sign_tid = danger_sign_tid
        if danger_sign_name is not None:
            self.danger_sign_name = danger_sign_name
        if comment is not None:
            self.comment = comment

    @property
    def danger_obs_id(self):
        """Gets the danger_obs_id of this DangerObsViewModel.  # noqa: E501


        :return: The danger_obs_id of this DangerObsViewModel.  # noqa: E501
        :rtype: int
        """
        return self._danger_obs_id

    @danger_obs_id.setter
    def danger_obs_id(self, danger_obs_id):
        """Sets the danger_obs_id of this DangerObsViewModel.


        :param danger_obs_id: The danger_obs_id of this DangerObsViewModel.  # noqa: E501
        :type: int
        """

        self._danger_obs_id = danger_obs_id

    @property
    def geo_hazard_tid(self):
        """Gets the geo_hazard_tid of this DangerObsViewModel.  # noqa: E501


        :return: The geo_hazard_tid of this DangerObsViewModel.  # noqa: E501
        :rtype: int
        """
        return self._geo_hazard_tid

    @geo_hazard_tid.setter
    def geo_hazard_tid(self, geo_hazard_tid):
        """Sets the geo_hazard_tid of this DangerObsViewModel.


        :param geo_hazard_tid: The geo_hazard_tid of this DangerObsViewModel.  # noqa: E501
        :type: int
        """

        self._geo_hazard_tid = geo_hazard_tid

    @property
    def geo_hazard_name(self):
        """Gets the geo_hazard_name of this DangerObsViewModel.  # noqa: E501


        :return: The geo_hazard_name of this DangerObsViewModel.  # noqa: E501
        :rtype: str
        """
        return self._geo_hazard_name

    @geo_hazard_name.setter
    def geo_hazard_name(self, geo_hazard_name):
        """Sets the geo_hazard_name of this DangerObsViewModel.


        :param geo_hazard_name: The geo_hazard_name of this DangerObsViewModel.  # noqa: E501
        :type: str
        """

        self._geo_hazard_name = geo_hazard_name

    @property
    def danger_sign_tid(self):
        """Gets the danger_sign_tid of this DangerObsViewModel.  # noqa: E501


        :return: The danger_sign_tid of this DangerObsViewModel.  # noqa: E501
        :rtype: int
        """
        return self._danger_sign_tid

    @danger_sign_tid.setter
    def danger_sign_tid(self, danger_sign_tid):
        """Sets the danger_sign_tid of this DangerObsViewModel.


        :param danger_sign_tid: The danger_sign_tid of this DangerObsViewModel.  # noqa: E501
        :type: int
        """

        self._danger_sign_tid = danger_sign_tid

    @property
    def danger_sign_name(self):
        """Gets the danger_sign_name of this DangerObsViewModel.  # noqa: E501


        :return: The danger_sign_name of this DangerObsViewModel.  # noqa: E501
        :rtype: str
        """
        return self._danger_sign_name

    @danger_sign_name.setter
    def danger_sign_name(self, danger_sign_name):
        """Sets the danger_sign_name of this DangerObsViewModel.


        :param danger_sign_name: The danger_sign_name of this DangerObsViewModel.  # noqa: E501
        :type: str
        """

        self._danger_sign_name = danger_sign_name

    @property
    def comment(self):
        """Gets the comment of this DangerObsViewModel.  # noqa: E501


        :return: The comment of this DangerObsViewModel.  # noqa: E501
        :rtype: str
        """
        return self._comment

    @comment.setter
    def comment(self, comment):
        """Sets the comment of this DangerObsViewModel.


        :param comment: The comment of this DangerObsViewModel.  # noqa: E501
        :type: str
        """

        self._comment = comment

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DangerObsViewModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DangerObsViewModel):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
