# coding: utf-8

"""
    RegObs API

      ## Introduction    RegObs is a tool for collecting observations and events   related to natural hazards. It is currently used by the   Norwegian flood, landslide and avalanche warning service in   Norway, but the data is openly available for anyone through this API.    Regobs has been developed by the Norwegian Water resources and   Energy Directorate (NVE), in collaboration with the Norwegian   Meteorological Institute (MET) and the Norwegian Public Roads   Administration (NPRA).    You can check out our representation of the data at [regobs.no](http://regobs.no).    ## Authentication    Some endpoints require an api key.  You can get an API key by sending an email to   [raek@nve.no](mailto:raek@nve.no?subject=RegObs%20API%20Key).  To use the api key with the swagger ui, fill in the api\\_key input above.   It should then be included with every request in the   `regObs_apptoken` header.    ## Getting started    Get the last 10 observations using python:    ```python  import requests  r = requests.post('https://api.regobs.no/v4/Search',       data={'NumberOfRecords': 10},      headers={'Content-Type': 'application/json'}  )  data = r.json()  print(len(data))  # 10  ```      # noqa: E501

    OpenAPI spec version: v4
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class HelptextDto(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'registration_tid': 'int',
        'geo_hazard_tid': 'int',
        'lang_key': 'int',
        'text': 'str'
    }

    attribute_map = {
        'registration_tid': 'RegistrationTID',
        'geo_hazard_tid': 'GeoHazardTID',
        'lang_key': 'LangKey',
        'text': 'Text'
    }

    def __init__(self, registration_tid=None, geo_hazard_tid=None, lang_key=None, text=None):  # noqa: E501
        """HelptextDto - a model defined in Swagger"""  # noqa: E501
        self._registration_tid = None
        self._geo_hazard_tid = None
        self._lang_key = None
        self._text = None
        self.discriminator = None
        if registration_tid is not None:
            self.registration_tid = registration_tid
        if geo_hazard_tid is not None:
            self.geo_hazard_tid = geo_hazard_tid
        if lang_key is not None:
            self.lang_key = lang_key
        if text is not None:
            self.text = text

    @property
    def registration_tid(self):
        """Gets the registration_tid of this HelptextDto.  # noqa: E501


        :return: The registration_tid of this HelptextDto.  # noqa: E501
        :rtype: int
        """
        return self._registration_tid

    @registration_tid.setter
    def registration_tid(self, registration_tid):
        """Sets the registration_tid of this HelptextDto.


        :param registration_tid: The registration_tid of this HelptextDto.  # noqa: E501
        :type: int
        """

        self._registration_tid = registration_tid

    @property
    def geo_hazard_tid(self):
        """Gets the geo_hazard_tid of this HelptextDto.  # noqa: E501


        :return: The geo_hazard_tid of this HelptextDto.  # noqa: E501
        :rtype: int
        """
        return self._geo_hazard_tid

    @geo_hazard_tid.setter
    def geo_hazard_tid(self, geo_hazard_tid):
        """Sets the geo_hazard_tid of this HelptextDto.


        :param geo_hazard_tid: The geo_hazard_tid of this HelptextDto.  # noqa: E501
        :type: int
        """

        self._geo_hazard_tid = geo_hazard_tid

    @property
    def lang_key(self):
        """Gets the lang_key of this HelptextDto.  # noqa: E501


        :return: The lang_key of this HelptextDto.  # noqa: E501
        :rtype: int
        """
        return self._lang_key

    @lang_key.setter
    def lang_key(self, lang_key):
        """Sets the lang_key of this HelptextDto.


        :param lang_key: The lang_key of this HelptextDto.  # noqa: E501
        :type: int
        """

        self._lang_key = lang_key

    @property
    def text(self):
        """Gets the text of this HelptextDto.  # noqa: E501


        :return: The text of this HelptextDto.  # noqa: E501
        :rtype: str
        """
        return self._text

    @text.setter
    def text(self, text):
        """Sets the text of this HelptextDto.


        :param text: The text of this HelptextDto.  # noqa: E501
        :type: str
        """

        self._text = text

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(HelptextDto, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HelptextDto):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
