# coding: utf-8

"""
    RegObs API

      ## Introduction    RegObs is a tool for collecting observations and events   related to natural hazards. It is currently used by the   Norwegian flood, landslide and avalanche warning service in   Norway, but the data is openly available for anyone through this API.    Regobs has been developed by the Norwegian Water resources and   Energy Directorate (NVE), in collaboration with the Norwegian   Meteorological Institute (MET) and the Norwegian Public Roads   Administration (NPRA).    You can check out our representation of the data at [regobs.no](http://regobs.no).    ## Authentication    Some endpoints require an api key.  You can get an API key by sending an email to   [raek@nve.no](mailto:raek@nve.no?subject=RegObs%20API%20Key).  To use the api key with the swagger ui, fill in the api\\_key input above.   It should then be included with every request in the   `regObs_apptoken` header.    ## Getting started    Get the last 10 observations using python:    ```python  import requests  r = requests.post('https://api.regobs.no/v4/Search',       data={'NumberOfRecords': 10},      headers={'Content-Type': 'application/json'}  )  data = r.json()  print(len(data))  # 10  ```      # noqa: E501

    OpenAPI spec version: v4
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class IceCoverObsDto(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'ice_cover_after_tid': 'int',
        'ice_cover_before_tid': 'int',
        'ice_cover_tid': 'int',
        'ice_capacity_tid': 'int',
        'ice_skateability_tid': 'int',
        'usage_flag_tid': 'int',
        'comment': 'str'
    }

    attribute_map = {
        'ice_cover_after_tid': 'IceCoverAfterTID',
        'ice_cover_before_tid': 'IceCoverBeforeTID',
        'ice_cover_tid': 'IceCoverTID',
        'ice_capacity_tid': 'IceCapacityTID',
        'ice_skateability_tid': 'IceSkateabilityTID',
        'usage_flag_tid': 'UsageFlagTID',
        'comment': 'Comment'
    }

    def __init__(self, ice_cover_after_tid=None, ice_cover_before_tid=None, ice_cover_tid=None, ice_capacity_tid=None, ice_skateability_tid=None, usage_flag_tid=None, comment=None):  # noqa: E501
        """IceCoverObsDto - a model defined in Swagger"""  # noqa: E501
        self._ice_cover_after_tid = None
        self._ice_cover_before_tid = None
        self._ice_cover_tid = None
        self._ice_capacity_tid = None
        self._ice_skateability_tid = None
        self._usage_flag_tid = None
        self._comment = None
        self.discriminator = None
        if ice_cover_after_tid is not None:
            self.ice_cover_after_tid = ice_cover_after_tid
        if ice_cover_before_tid is not None:
            self.ice_cover_before_tid = ice_cover_before_tid
        if ice_cover_tid is not None:
            self.ice_cover_tid = ice_cover_tid
        if ice_capacity_tid is not None:
            self.ice_capacity_tid = ice_capacity_tid
        if ice_skateability_tid is not None:
            self.ice_skateability_tid = ice_skateability_tid
        if usage_flag_tid is not None:
            self.usage_flag_tid = usage_flag_tid
        if comment is not None:
            self.comment = comment

    @property
    def ice_cover_after_tid(self):
        """Gets the ice_cover_after_tid of this IceCoverObsDto.  # noqa: E501


        :return: The ice_cover_after_tid of this IceCoverObsDto.  # noqa: E501
        :rtype: int
        """
        return self._ice_cover_after_tid

    @ice_cover_after_tid.setter
    def ice_cover_after_tid(self, ice_cover_after_tid):
        """Sets the ice_cover_after_tid of this IceCoverObsDto.


        :param ice_cover_after_tid: The ice_cover_after_tid of this IceCoverObsDto.  # noqa: E501
        :type: int
        """

        self._ice_cover_after_tid = ice_cover_after_tid

    @property
    def ice_cover_before_tid(self):
        """Gets the ice_cover_before_tid of this IceCoverObsDto.  # noqa: E501

        Hvordan har vannet vært isdekt før den aktuelle observajonen? Feks var det isfritt? Feltet sier noe om hvordan utviklingen er. The IceCoverBeforeKD unique identifier  # noqa: E501

        :return: The ice_cover_before_tid of this IceCoverObsDto.  # noqa: E501
        :rtype: int
        """
        return self._ice_cover_before_tid

    @ice_cover_before_tid.setter
    def ice_cover_before_tid(self, ice_cover_before_tid):
        """Sets the ice_cover_before_tid of this IceCoverObsDto.

        Hvordan har vannet vært isdekt før den aktuelle observajonen? Feks var det isfritt? Feltet sier noe om hvordan utviklingen er. The IceCoverBeforeKD unique identifier  # noqa: E501

        :param ice_cover_before_tid: The ice_cover_before_tid of this IceCoverObsDto.  # noqa: E501
        :type: int
        """

        self._ice_cover_before_tid = ice_cover_before_tid

    @property
    def ice_cover_tid(self):
        """Gets the ice_cover_tid of this IceCoverObsDto.  # noqa: E501

        Hvordan er vannet dekket av is nå. The IceCoverKD unique identifier  # noqa: E501

        :return: The ice_cover_tid of this IceCoverObsDto.  # noqa: E501
        :rtype: int
        """
        return self._ice_cover_tid

    @ice_cover_tid.setter
    def ice_cover_tid(self, ice_cover_tid):
        """Sets the ice_cover_tid of this IceCoverObsDto.

        Hvordan er vannet dekket av is nå. The IceCoverKD unique identifier  # noqa: E501

        :param ice_cover_tid: The ice_cover_tid of this IceCoverObsDto.  # noqa: E501
        :type: int
        """

        self._ice_cover_tid = ice_cover_tid

    @property
    def ice_capacity_tid(self):
        """Gets the ice_capacity_tid of this IceCoverObsDto.  # noqa: E501

        Bæreevne. IceCapacityKD unique identifier  # noqa: E501

        :return: The ice_capacity_tid of this IceCoverObsDto.  # noqa: E501
        :rtype: int
        """
        return self._ice_capacity_tid

    @ice_capacity_tid.setter
    def ice_capacity_tid(self, ice_capacity_tid):
        """Sets the ice_capacity_tid of this IceCoverObsDto.

        Bæreevne. IceCapacityKD unique identifier  # noqa: E501

        :param ice_capacity_tid: The ice_capacity_tid of this IceCoverObsDto.  # noqa: E501
        :type: int
        """

        self._ice_capacity_tid = ice_capacity_tid

    @property
    def ice_skateability_tid(self):
        """Gets the ice_skateability_tid of this IceCoverObsDto.  # noqa: E501

        Skøytebarhet. IceSkateabilityKD unique identifier  # noqa: E501

        :return: The ice_skateability_tid of this IceCoverObsDto.  # noqa: E501
        :rtype: int
        """
        return self._ice_skateability_tid

    @ice_skateability_tid.setter
    def ice_skateability_tid(self, ice_skateability_tid):
        """Sets the ice_skateability_tid of this IceCoverObsDto.

        Skøytebarhet. IceSkateabilityKD unique identifier  # noqa: E501

        :param ice_skateability_tid: The ice_skateability_tid of this IceCoverObsDto.  # noqa: E501
        :type: int
        """

        self._ice_skateability_tid = ice_skateability_tid

    @property
    def usage_flag_tid(self):
        """Gets the usage_flag_tid of this IceCoverObsDto.  # noqa: E501

        Flagger en observasjon som godkjent, underkjent, overført historisk database mm. The UsageFlagKD unique identifier  # noqa: E501

        :return: The usage_flag_tid of this IceCoverObsDto.  # noqa: E501
        :rtype: int
        """
        return self._usage_flag_tid

    @usage_flag_tid.setter
    def usage_flag_tid(self, usage_flag_tid):
        """Sets the usage_flag_tid of this IceCoverObsDto.

        Flagger en observasjon som godkjent, underkjent, overført historisk database mm. The UsageFlagKD unique identifier  # noqa: E501

        :param usage_flag_tid: The usage_flag_tid of this IceCoverObsDto.  # noqa: E501
        :type: int
        """

        self._usage_flag_tid = usage_flag_tid

    @property
    def comment(self):
        """Gets the comment of this IceCoverObsDto.  # noqa: E501

        Kommentarfelt for å skrive utfyllende tekst om observasjonen.  # noqa: E501

        :return: The comment of this IceCoverObsDto.  # noqa: E501
        :rtype: str
        """
        return self._comment

    @comment.setter
    def comment(self, comment):
        """Sets the comment of this IceCoverObsDto.

        Kommentarfelt for å skrive utfyllende tekst om observasjonen.  # noqa: E501

        :param comment: The comment of this IceCoverObsDto.  # noqa: E501
        :type: str
        """

        self._comment = comment

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IceCoverObsDto, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IceCoverObsDto):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
