# coding: utf-8

"""
    RegObs API

      ## Introduction    RegObs is a tool for collecting observations and events   related to natural hazards. It is currently used by the   Norwegian flood, landslide and avalanche warning service in   Norway, but the data is openly available for anyone through this API.    Regobs has been developed by the Norwegian Water resources and   Energy Directorate (NVE), in collaboration with the Norwegian   Meteorological Institute (MET) and the Norwegian Public Roads   Administration (NPRA).    You can check out our representation of the data at [regobs.no](http://regobs.no).    ## Authentication    Some endpoints require an api key.  You can get an API key by sending an email to   [raek@nve.no](mailto:raek@nve.no?subject=RegObs%20API%20Key).  To use the api key with the swagger ui, fill in the api\\_key input above.   It should then be included with every request in the   `regObs_apptoken` header.    ## Getting started    Get the last 10 observations using python:    ```python  import requests  r = requests.post('https://api.regobs.no/v4/Search',       data={'NumberOfRecords': 10},      headers={'Content-Type': 'application/json'}  )  data = r.json()  print(len(data))  # 10  ```      # noqa: E501

    OpenAPI spec version: v4
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class IceThicknessLayerDto(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'usage_flag_tid': 'int',
        'ice_layer_tid': 'int',
        'ice_layer_thickness': 'float',
        'comment': 'str'
    }

    attribute_map = {
        'usage_flag_tid': 'UsageFlagTID',
        'ice_layer_tid': 'IceLayerTID',
        'ice_layer_thickness': 'IceLayerThickness',
        'comment': 'Comment'
    }

    def __init__(self, usage_flag_tid=None, ice_layer_tid=None, ice_layer_thickness=None, comment=None):  # noqa: E501
        """IceThicknessLayerDto - a model defined in Swagger"""  # noqa: E501
        self._usage_flag_tid = None
        self._ice_layer_tid = None
        self._ice_layer_thickness = None
        self._comment = None
        self.discriminator = None
        if usage_flag_tid is not None:
            self.usage_flag_tid = usage_flag_tid
        if ice_layer_tid is not None:
            self.ice_layer_tid = ice_layer_tid
        if ice_layer_thickness is not None:
            self.ice_layer_thickness = ice_layer_thickness
        if comment is not None:
            self.comment = comment

    @property
    def usage_flag_tid(self):
        """Gets the usage_flag_tid of this IceThicknessLayerDto.  # noqa: E501


        :return: The usage_flag_tid of this IceThicknessLayerDto.  # noqa: E501
        :rtype: int
        """
        return self._usage_flag_tid

    @usage_flag_tid.setter
    def usage_flag_tid(self, usage_flag_tid):
        """Sets the usage_flag_tid of this IceThicknessLayerDto.


        :param usage_flag_tid: The usage_flag_tid of this IceThicknessLayerDto.  # noqa: E501
        :type: int
        """

        self._usage_flag_tid = usage_flag_tid

    @property
    def ice_layer_tid(self):
        """Gets the ice_layer_tid of this IceThicknessLayerDto.  # noqa: E501

        The IceLayerKD unique identifier  # noqa: E501

        :return: The ice_layer_tid of this IceThicknessLayerDto.  # noqa: E501
        :rtype: int
        """
        return self._ice_layer_tid

    @ice_layer_tid.setter
    def ice_layer_tid(self, ice_layer_tid):
        """Sets the ice_layer_tid of this IceThicknessLayerDto.

        The IceLayerKD unique identifier  # noqa: E501

        :param ice_layer_tid: The ice_layer_tid of this IceThicknessLayerDto.  # noqa: E501
        :type: int
        """

        self._ice_layer_tid = ice_layer_tid

    @property
    def ice_layer_thickness(self):
        """Gets the ice_layer_thickness of this IceThicknessLayerDto.  # noqa: E501

        IceLayerThickness  # noqa: E501

        :return: The ice_layer_thickness of this IceThicknessLayerDto.  # noqa: E501
        :rtype: float
        """
        return self._ice_layer_thickness

    @ice_layer_thickness.setter
    def ice_layer_thickness(self, ice_layer_thickness):
        """Sets the ice_layer_thickness of this IceThicknessLayerDto.

        IceLayerThickness  # noqa: E501

        :param ice_layer_thickness: The ice_layer_thickness of this IceThicknessLayerDto.  # noqa: E501
        :type: float
        """

        self._ice_layer_thickness = ice_layer_thickness

    @property
    def comment(self):
        """Gets the comment of this IceThicknessLayerDto.  # noqa: E501

        Comment  # noqa: E501

        :return: The comment of this IceThicknessLayerDto.  # noqa: E501
        :rtype: str
        """
        return self._comment

    @comment.setter
    def comment(self, comment):
        """Sets the comment of this IceThicknessLayerDto.

        Comment  # noqa: E501

        :param comment: The comment of this IceThicknessLayerDto.  # noqa: E501
        :type: str
        """

        self._comment = comment

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IceThicknessLayerDto, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IceThicknessLayerDto):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
