# coding: utf-8

"""
    RegObs API

      ## Introduction    RegObs is a tool for collecting observations and events   related to natural hazards. It is currently used by the   Norwegian flood, landslide and avalanche warning service in   Norway, but the data is openly available for anyone through this API.    Regobs has been developed by the Norwegian Water resources and   Energy Directorate (NVE), in collaboration with the Norwegian   Meteorological Institute (MET) and the Norwegian Public Roads   Administration (NPRA).    You can check out our representation of the data at [regobs.no](http://regobs.no).    ## Authentication    Some endpoints require an api key.  You can get an API key by sending an email to   [raek@nve.no](mailto:raek@nve.no?subject=RegObs%20API%20Key).  To use the api key with the swagger ui, fill in the api\\_key input above.   It should then be included with every request in the   `regObs_apptoken` header.    ## Getting started    Get the last 10 observations using python:    ```python  import requests  r = requests.post('https://api.regobs.no/v4/Search',       data={'NumberOfRecords': 10},      headers={'Content-Type': 'application/json'}  )  data = r.json()  print(len(data))  # 10  ```      # noqa: E501

    OpenAPI spec version: v4
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class ObserverGroupDto(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'int',
        'name': 'str',
        'observer_group_description': 'str',
        'work_place': 'str',
        'comment': 'str'
    }

    attribute_map = {
        'id': 'Id',
        'name': 'Name',
        'observer_group_description': 'ObserverGroupDescription',
        'work_place': 'WorkPlace',
        'comment': 'Comment'
    }

    def __init__(self, id=None, name=None, observer_group_description=None, work_place=None, comment=None):  # noqa: E501
        """ObserverGroupDto - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._observer_group_description = None
        self._work_place = None
        self._comment = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if observer_group_description is not None:
            self.observer_group_description = observer_group_description
        if work_place is not None:
            self.work_place = work_place
        if comment is not None:
            self.comment = comment

    @property
    def id(self):
        """Gets the id of this ObserverGroupDto.  # noqa: E501


        :return: The id of this ObserverGroupDto.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ObserverGroupDto.


        :param id: The id of this ObserverGroupDto.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this ObserverGroupDto.  # noqa: E501


        :return: The name of this ObserverGroupDto.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ObserverGroupDto.


        :param name: The name of this ObserverGroupDto.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def observer_group_description(self):
        """Gets the observer_group_description of this ObserverGroupDto.  # noqa: E501


        :return: The observer_group_description of this ObserverGroupDto.  # noqa: E501
        :rtype: str
        """
        return self._observer_group_description

    @observer_group_description.setter
    def observer_group_description(self, observer_group_description):
        """Sets the observer_group_description of this ObserverGroupDto.


        :param observer_group_description: The observer_group_description of this ObserverGroupDto.  # noqa: E501
        :type: str
        """

        self._observer_group_description = observer_group_description

    @property
    def work_place(self):
        """Gets the work_place of this ObserverGroupDto.  # noqa: E501


        :return: The work_place of this ObserverGroupDto.  # noqa: E501
        :rtype: str
        """
        return self._work_place

    @work_place.setter
    def work_place(self, work_place):
        """Sets the work_place of this ObserverGroupDto.


        :param work_place: The work_place of this ObserverGroupDto.  # noqa: E501
        :type: str
        """

        self._work_place = work_place

    @property
    def comment(self):
        """Gets the comment of this ObserverGroupDto.  # noqa: E501


        :return: The comment of this ObserverGroupDto.  # noqa: E501
        :rtype: str
        """
        return self._comment

    @comment.setter
    def comment(self, comment):
        """Sets the comment of this ObserverGroupDto.


        :param comment: The comment of this ObserverGroupDto.  # noqa: E501
        :type: str
        """

        self._comment = comment

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ObserverGroupDto, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ObserverGroupDto):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
